diff --git a/xen/common/libfdt/libfdt_internal.h b/xen/common/libfdt/libfdt_internal.h
index 16bda1906a..ba4d6527b0 100644
--- a/xen/common/libfdt/libfdt_internal.h
+++ b/xen/common/libfdt/libfdt_internal.h
@@ -1,6 +1,6 @@
 /* SPDX-License-Identifier: (GPL-2.0-or-later OR BSD-2-Clause) */
-#ifndef LIBFDT_INTERNAL_H
-#define LIBFDT_INTERNAL_H
+#ifndef COMMON__LIBFDT__LIBFDT_INTERNAL_H
+#define COMMON__LIBFDT__LIBFDT_INTERNAL_H
 /*
  * libfdt - Flat Device Tree manipulation
  * Copyright (C) 2006 David Gibson, IBM Corporation.
@@ -189,4 +189,4 @@ static inline bool can_assume_(int mask)
 /** helper macros for checking assumptions */
 #define can_assume(_assume)	can_assume_(ASSUME_ ## _assume)
 
-#endif /* LIBFDT_INTERNAL_H */
+#endif /* COMMON__LIBFDT__LIBFDT_INTERNAL_H */
diff --git a/xen/include/xen/bootfdt.h b/xen/include/xen/bootfdt.h
index 16fa05f38f..7cb01dbb1b 100644
--- a/xen/include/xen/bootfdt.h
+++ b/xen/include/xen/bootfdt.h
@@ -1,5 +1,5 @@
-#ifndef XEN_BOOTFDT_H
-#define XEN_BOOTFDT_H
+#ifndef XEN__BOOTFDT_H
+#define XEN__BOOTFDT_H
 
 #include <xen/types.h>
 #include <xen/kernel.h>
@@ -206,4 +206,4 @@ static inline struct shmem_membank_extra *bootinfo_get_shmem_extra(void)
 }
 #endif
 
-#endif /* XEN_BOOTFDT_H */
+#endif /* XEN__BOOTFDT_H */
diff --git a/xen/include/xen/device_tree.h b/xen/include/xen/device_tree.h
index e6287305a7..5c4a419781 100644
--- a/xen/include/xen/device_tree.h
+++ b/xen/include/xen/device_tree.h
@@ -7,8 +7,8 @@
  * it under the terms of the GNU General Public License version 2 as
  * published by the Free Software Foundation.
  */
-#ifndef __XEN_DEVICE_TREE_H__
-#define __XEN_DEVICE_TREE_H__
+#ifndef XEN__DEVICE_TREE_H
+#define XEN__DEVICE_TREE_H
 
 #include <asm/byteorder.h>
 #include <asm/device.h>
diff --git a/xen/include/xen/libfdt/fdt.h b/xen/include/xen/libfdt/fdt.h
index f2e68807f2..6a53d4705b 100644
--- a/xen/include/xen/libfdt/fdt.h
+++ b/xen/include/xen/libfdt/fdt.h
@@ -1,6 +1,6 @@
 /* SPDX-License-Identifier: (GPL-2.0-or-later OR BSD-2-Clause) */
-#ifndef FDT_H
-#define FDT_H
+#ifndef XEN__LIBFDT__FDT_H
+#define XEN__LIBFDT__FDT_H
 /*
  * libfdt - Flat Device Tree manipulation
  * Copyright (C) 2006 David Gibson, IBM Corporation.
@@ -63,4 +63,4 @@ struct fdt_property {
 #define FDT_V16_SIZE	FDT_V3_SIZE
 #define FDT_V17_SIZE	(FDT_V16_SIZE + sizeof(fdt32_t))
 
-#endif /* FDT_H */
+#endif /* XEN__LIBFDT__FDT_H */
diff --git a/xen/include/xen/libfdt/libfdt-xen.h b/xen/include/xen/libfdt/libfdt-xen.h
index a5340bc9f4..7cab9cef66 100644
--- a/xen/include/xen/libfdt/libfdt-xen.h
+++ b/xen/include/xen/libfdt/libfdt-xen.h
@@ -8,8 +8,8 @@
  * Copyright (C) 2023, Advanced Micro Devices, Inc. All Rights Reserved.
  */
 
-#ifndef LIBFDT_XEN_H
-#define LIBFDT_XEN_H
+#ifndef XEN__LIBFDT__LIBFDT_XEN_H
+#define XEN__LIBFDT__LIBFDT_XEN_H
 
 #include <xen/libfdt/libfdt.h>
 
@@ -43,7 +43,7 @@ static inline int fdt_get_mem_rsv_paddr(const void *fdt, int n,
     return ret;
 }
 
-#endif /* LIBFDT_XEN_H */
+#endif /* XEN__LIBFDT__LIBFDT_XEN_H */
 
 /*
  * Local variables:
diff --git a/xen/include/xen/libfdt/libfdt.h b/xen/include/xen/libfdt/libfdt.h
index fabddbee8c..9ed4ee1705 100644
--- a/xen/include/xen/libfdt/libfdt.h
+++ b/xen/include/xen/libfdt/libfdt.h
@@ -1,6 +1,6 @@
 /* SPDX-License-Identifier: (GPL-2.0-or-later OR BSD-2-Clause) */
-#ifndef LIBFDT_H
-#define LIBFDT_H
+#ifndef XEN__LIBFDT__LIBFDT_H
+#define XEN__LIBFDT__LIBFDT_H
 /*
  * libfdt - Flat Device Tree manipulation
  * Copyright (C) 2006 David Gibson, IBM Corporation.
@@ -2137,4 +2137,4 @@ const char *fdt_strerror(int errval);
 }
 #endif
 
-#endif /* LIBFDT_H */
+#endif /* XEN__LIBFDT__LIBFDT_H */
diff --git a/xen/include/xen/libfdt/libfdt_env.h b/xen/include/xen/libfdt/libfdt_env.h
index 8368787391..3b0d121a78 100644
--- a/xen/include/xen/libfdt/libfdt_env.h
+++ b/xen/include/xen/libfdt/libfdt_env.h
@@ -1,6 +1,6 @@
 /* SPDX-License-Identifier: (GPL-2.0-or-later OR BSD-2-Clause) */
-#ifndef LIBFDT_ENV_H
-#define LIBFDT_ENV_H
+#ifndef XEN__LIBFDT__LIBFDT_ENV_H
+#define XEN__LIBFDT__LIBFDT_ENV_H
 /*
  * libfdt - Flat Device Tree manipulation
  * Copyright (C) 2006 David Gibson, IBM Corporation.
@@ -93,4 +93,4 @@ static inline size_t fdt_strnlen(const char *string, size_t max_count)
 
 #endif /* __APPLE__ */
 
-#endif /* LIBFDT_ENV_H */
+#endif /* XEN__LIBFDT__LIBFDT_ENV_H */